# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::AccessUnitByteIO Class Reference

A random access point within a Dirac bytestream.

`#include <accessunit_byteio.h>`

Inheritance diagram for dirac::AccessUnitByteIO:

[legend]
Collaboration diagram for dirac::AccessUnitByteIO:

[legend]

List of all members.

## Public Member Functions

- AccessUnitByteIO (int &accessunit_fnum, SeqParams &seq_params, SourceParams &src_params)
    Constructor (encoding).
- AccessUnitByteIO (const ParseUnitByteIO &parseunit_byteio, SeqParams &seq_params, SourceParams &src_params, ParseParams &parse_params)
    Constructor (decoding).
- ~AccessUnitByteIO ()
    Destructor.
- bool Input ()
    Parses data in Dirac-stream format (decoding).
- void Output ()
    Writes access-unit info to Dirac stream-format (encoding).
- int GetIdNumber () const
    Get access-unit number.
- int GetSize () const
    Gets size (in bytes).
- ParseUnitType GetType () const
    Gets parse-unit type.

## Private Member Functions

- unsigned char CalcParseCode () const
    Calculates parse-code based on access-unit parameters (encoding).
- void InputDisplayParams ()
    Parse display attributes from bytestream-compatible input (decoding).
- void InputParseParams ()
    Parse parse attributes from bytestream-compatible input (decoding).
- void InputSequenceParams ()
    Parse sequence attributes from bytestream-compatible input (decoding).
- void OutputDisplayParams ()
    Output display attributes for bytestream-compatible output (encoding).
- void OutputParseParams ()
    Output parse attributes for bytestream-compatible output (encoding).
- void OutputSequenceParams ()
    Output sequence attributes for bytestream-compatible output (encoding).

## Private Attributes

- ParseParamsByteIO m_parseparams_byteio
    Parse-params byte input/output.
- SeqParams m_default_seq_params
    Default sequence parameters.
- SourceParams m_default_src_params
    Default source parameters.
- SeqParamsByteIO m_seqparams_byteio
    Sequence-params byte input/output.
- DisplayParamsByteIO m_displayparams_byteio
    Display-params byte input/output.

## Constructor & Destructor Documentation

dirac::AccessUnitByteIO::AccessUnitByteIO | ( | int & | accessunit_fnum,
|  | SeqParams & | seq_params,
|  | SourceParams & | src_params |
| ) |  |  |

Parameters:

  | accessunit_fnum | Current AccessUnit frame-number
  | seq_params | Sequence parameters for current AccessUnit
  | src_params | Source parameters for current AccessUnit

dirac::AccessUnitByteIO::AccessUnitByteIO | ( | const ParseUnitByteIO & | parseunit_byteio,
|  | SeqParams & | seq_params,
|  | SourceParams & | src_params,
|  | ParseParams & | parse_params |
| ) |  |  |

Parameters:

  | parseunit_byteio | Source of data
  | seq_params | Destination of sequence paramters data
  | src_params | Destination of source paramters data
  | parse_params | Destination of source paramters data

dirac::AccessUnitByteIO::~AccessUnitByteIO | ( |  | ) |

## Member Function Documentation

bool dirac::AccessUnitByteIO::Input | ( |  | ) |

Reimplemented from dirac::ParseUnitByteIO.

void dirac::AccessUnitByteIO::Output | ( |  | ) |

int dirac::AccessUnitByteIO::GetIdNumber | ( |  | ) | const

int dirac::AccessUnitByteIO::GetSize | ( |  | ) | const`[virtual]`

Reimplemented from dirac::ParseUnitByteIO.

ParseUnitType dirac::AccessUnitByteIO::GetType | ( |  | ) | const`[inline, virtual]`

Reimplemented from dirac::ParseUnitByteIO.

References dirac::PU_ACCESS_UNIT.

unsigned char dirac::AccessUnitByteIO::CalcParseCode | ( |  | ) | const`[private, virtual]`

Returns:
  Char bit-set

Reimplemented from dirac::ParseUnitByteIO.

void dirac::AccessUnitByteIO::InputDisplayParams | ( |  | ) | `[private]`

void dirac::AccessUnitByteIO::InputParseParams | ( |  | ) | `[private]`

void dirac::AccessUnitByteIO::InputSequenceParams | ( |  | ) | `[private]`

void dirac::AccessUnitByteIO::OutputDisplayParams | ( |  | ) | `[private]`

void dirac::AccessUnitByteIO::OutputParseParams | ( |  | ) | `[private]`

void dirac::AccessUnitByteIO::OutputSequenceParams | ( |  | ) | `[private]`

## Member Data Documentation

ParseParamsByteIO dirac::AccessUnitByteIO::m_parseparams_byteio `[private]`

SeqParams dirac::AccessUnitByteIO::m_default_seq_params `[private]`

SourceParams dirac::AccessUnitByteIO::m_default_src_params `[private]`

SeqParamsByteIO dirac::AccessUnitByteIO::m_seqparams_byteio `[private]`

DisplayParamsByteIO dirac::AccessUnitByteIO::m_displayparams_byteio `[private]`

The documentation for this class was generated from the following file:

- accessunit_byteio.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.